List of Prometheus metrics
List of the SonarQube Server metrics exposed by Prometheus.
Exposing metrics
SonarQube exposes metrics through two distinct mechanisms:
Web API (/api/monitoring/metrics)
All deployments (bare metal, Docker, Kubernetes)
Direct HTTP GET, authenticated with system passcode or bearer token.
JMX Exporter Java agent
Kubernetes / OpenShift only
Prometheus scrapes a separate port configured by the Helm chart. See the ArtifactHub’s Monitoring section for SonarQube Server (Developer and Enterprise) and SonarQube Server Data Center edition for more
Metrics exposed by the Web API
These metrics are available on all deployment types: bare metal, Docker, Kubernetes using GET /api/monitoring/metrics.
sonarqube_compute_engine_pending_tasks_total
Gauge
Tasks
Number of tasks pending in the Compute Engine queue at a given point in time. Shared value across all SonarQube instances.
sonarqube_compute_engine_tasks_running_duration_seconds
Summary
Seconds
Compute Engine task running time in seconds. Labels: task_type, project_key
sonarqube_compute_engine_system_tasks_running_duration_seconds
Summary
Seconds
Compute Engine system task running time in seconds. Label: task_type
sonarqube_elasticsearch_disk_space_free_bytes
Gauge
Bytes
Space left on device. Label: node_name
sonarqube_elasticsearch_disk_space_total_bytes
Gauge
Bytes
Total disk space on the device. Label: node_name
sonarqube_health_compute_engine_status
Gauge
N/A
Tells whether Compute Engine is up (healthy, ready to take tasks) or down. 1 for up, 0 for down.
sonarqube_health_elasticsearch_status
Gauge
N/A
Tells whether Elasticsearch is up or down. 1 for up, 0 for down.
sonarqube_health_integration_azuredevops_status
Gauge
N/A
Tells whether SonarQube has configured Azure DevOps integration and its status is green. 1 for green, 0 otherwise.
sonarqube_health_integration_bitbucket_status
Gauge
N/A
Tells whether SonarQube has configured Bitbucket integration and its status is green. 1 for green, 0 otherwise.
sonarqube_health_integration_github_status
Gauge
N/A
Tells whether SonarQube has configured GitHub integration and its status is green. 1 for green, 0 otherwise.
sonarqube_health_integration_gitlab_status
Gauge
N/A
Tells whether SonarQube has configured GitLab integration and its status is green. 1 for green, 0 otherwise.
sonarqube_health_web_status
Gauge
N/A
Tells whether the Web process is up or down. 1 for up, 0 for down.
sonarqube_license_days_before_expiration_total
Gauge
Days
Days until the SonarQube license will expire.
sonarqube_license_number_of_lines_analyzed_total
Gauge
Lines
Number of lines analyzed.
sonarqube_license_number_of_lines_remaining_total
Gauge
Lines
Number of lines remaining until the current license limit is reached.
sonarqube_number_of_connected_sonarlint_clients
Gauge
Clients
Number of connected SonarQube for IDE clients.
sonarqube_web_uptime_minutes
Gauge
Mintues
Number of minutes the SonarQube instance has been running.
JMX metrics (Kubernetes and OpenShift only)
The following metrics require the Prometheus JMX Exporter Java agent, which is configured automatically by the SonarQube Helm chart and attached to both the Web and Compute Engine JVM processes. On Kubernetes and OpenShift, the SonarQube Helm chart configures this automatically when:
prometheusExporter.enabled: true(sonarqubeHelm chart), orapplicationNodes.prometheusExporter.enabled: true(sonarqube-dceHelm chart)
For non-Kubernetes deployment and JMX metrics, see Monitoring SonarQube Server instance.
Enabling metrics collection on Kubernetes
See Introduction to setting up monitoring for enabling metrics collection.
Prometheus scrapes metrics from dedicated ports, which are defined and configurable within the Helm chart.
Default Port
8000
8001
SonarQube Helm Chart Key
prometheusExporter.webBeanPort
prometheusExporter.ceBeanPort
SonarQube DCE Helm Chart Key
applicationNodes.prometheusExporter.webBeanPort
applicationNodes.prometheusExporter.ceBeanPort
See the ArtifactHub’s Monitoring section for SonarQube Server (Developer and Enterprise) and SonarQube Server Data Center edition for more details.
Web server: database connection pool
JMX object: SonarQube:name=Database
SonarQube_Database_PoolActiveConnections
Untyped
Connections
Number of active connections in the database pool.
SonarQube_Database_PoolIdleConnections
Untyped
Connections
Number of idle connections in the database pool.
SonarQube_Database_PoolMaxConnections
Untyped
Connections
Maximum number of connections to the database pool.
SonarQube_Database_PoolMaxLifeTimeMillis
Untyped
Milliseconds
Maximum time a connection can stay alive in the database pool.
SonarQube_Database_PoolMaxWaitMillis
Untyped
Milliseconds
Maximum time a connection can keep waiting in the database pool.
SonarQube_Database_PoolMinIdleConnections
Untyped
Connections
Minimum number of idle connections in the database pool.
SonarQube_Database_PoolTotalConnections
Untyped
Connections
Total number of connections to the database pool.
Web server: async execution
JMX object: SonarQube:name=AsyncExecution
SonarQube_AsyncExecution_LargestWorkerCount
Untyped
Workers
Maximum number of asynchronous workers seen since startup.
SonarQube_AsyncExecution_QueueSize
Untyped
N/A
Current queue size for asynchronous jobs.
SonarQube_AsyncExecution_WorkerCount
Untyped
Workers
Current number of asynchronous job workers.
SonarQube Compute Engine and Web JVM process metrics
The following metrics are standard JVM process metrics emitted by the JMX Prometheus Java agent itself (not SonarQube-specific MBeans). Because the agent runs inside both the Web and CE JVM processes, these metrics are available from both scrape targets:
Port 8000 (
monitoring-web): values reflect the Web server JVM processPort 8001 (
monitoring-ce): values reflect the Compute Engine (CE) JVM process
Use the instance or port label in Prometheus to distinguish between the two when building dashboards or alerts.
process_cpu_seconds_total
Counter
Seconds
Total user and system CPU time
process_max_fds
Gauge
N/A
Maximum number of open file descriptors.
process_open_fds
Gauge
N/A
Number of open file descriptors.
process_resident_memory_bytes
Gauge
Bytes
Resident memory size in bytes.
process_start_time_seconds
Gauge
Seconds
Start time of the process since Unix epoch in seconds.
process_virtual_memory_bytes
Gauge
Bytes
Virtual memory size in bytes
.
SonarQube Compute Engine database connection pool
JMX object: SonarQube:name=ComputeEngineDatabaseConnection
SonarQube_ComputeEngineDatabaseConnection_PoolActiveConnections
Untyped
Connections
Number of active connections in the Compute Engine database pool.
SonarQube_ComputeEngineDatabaseConnection_PoolIdleConnections
Untyped
Connections
Number of idle connections in the Compute Engine database pool.
SonarQube_ComputeEngineDatabaseConnection_PoolMaxConnections
Untyped
Connections
Maximum number of connections to the Compute Engine database pool.
SonarQube_ComputeEngineDatabaseConnection_PoolMaxLifeTimeMillis
Untyped
Milliseconds
Maximum time a connection can stay alive in the Compute Engine database pool.
SonarQube_ComputeEngineDatabaseConnection_PoolMaxWaitMillis
Untyped
Milliseconds
Maximum time a connection can keep waiting in the Compute Engine database pool.
SonarQube_ComputeEngineDatabaseConnection_PoolMinIdleConnections
Untyped
Connections
Minimum number of idle connections in the Compute Engine database pool.
SonarQube_ComputeEngineDatabaseConnection_PoolTotalConnections
Untyped
Connections
Total number of connections to the Compute Engine database pool.
SonarQube Compute Engine tasks
JMX object: SonarQube:name=ComputeEngineTasks
SonarQube_ComputeEngineTasks_ErrorCount
Untyped
Tasks
Number of Compute Engine tasks whose processing ended with an error since instance startup.
SonarQube_ComputeEngineTasks_InProgressCount
Untyped
Tasks
Number of Compute Engine tasks currently being processed.
SonarQube_ComputeEngineTasks_LongestTimePending
Untyped
Milliseconds
Age in milliseconds of the oldest pending task.
SonarQube_ComputeEngineTasks_PendingCount
Untyped
Tasks
Number of pending Compute Engine tasks, including tasks received before instance startup.
SonarQube_ComputeEngineTasks_ProcessingTime
Untyped
Milliseconds
Total time spent processing Compute Engine tasks since instance startup.
SonarQube_ComputeEngineTasks_SuccessCount
Untyped
Tasks
Number of Compute Engine tasks whose processing ended successfully since instance startup.
SonarQube_ComputeEngineTasks_WorkerCount
Untyped
Workers
Configured number of Compute Engine workers.
SonarQube_ComputeEngineTasks_WorkerMaxCount
Untyped
Workers
Configured maximum number of Compute Engine workers.
Tomcat
The following metrics come from Tomcat, they are all untyped.
Connector
Tomcat_Connector_portOffset
The offset that will be applied to the port to determine the actual port number used.
Tomcat_Connector_maxThreads
The maximum number of request processing threads to be created for the internal Executor. -1 indicates an external Executor is being used.
Tomcat_Connector_tcpNoDelay
Should we use TCP no delay?
Tomcat_Connector_maxParameterCount
The maximum number of parameters (GET plus POST) that will be automatically parsed by the container. 10000 by default. The default Tomcat server.xml configures a lower default of 1000. A value of less than 0 means no limit.
Tomcat_Connector_maxHeaderCount
The maximum number of headers that are allowed by the container. 100 by default. A value of less than 0 means no limit.
Tomcat_Connector_maxKeepAliveRequests
Maximum number of Keep-Alive requests to honor per connection.
Tomcat_Connector_allowTrace
Allow disabling TRACE method.
Tomcat_Connector_enableLookups
The ‘enable DNS lookups’ flag for this Connector.
Tomcat_Connector_localPort
The port number on which this connector is listening to requests. If the special value for port of zero is used then this method will report the actual port bound.
Tomcat_Connector_threadPriority
The thread priority for processors using the internal Executor. -1 indicates an external Executor is being used.
Tomcat_Connector_processorCache
The processor cache size.
Tomcat_Connector_xpoweredBy
Is generation of X-Powered-By response header enabled/disabled?
Tomcat_Connector_useIPVHosts
Should IP-based virtual hosting be used?
Tomcat_Connector_port
The port number (excluding any offset) on which this connector is configured to listen for requests. The special value of 0 means select a random free port when the socket is bound.
Tomcat_Connector_redirectPort
The redirect port (excluding any offset) for non-SSL to SSL redirects.
Tomcat_Connector_proxyPort
The Server port to which we should pretend requests to this Connector.
Tomcat_Connector_acceptCount
The accept count for this Connector.
Tomcat_Connector_maxSwallowSize
The maximum number of request body bytes to be swallowed by Tomcat for an aborted upload.
Tomcat_Connector_portWithOffset
The actual port number (including any offset) on which this connector is configured to listen for requests.
Tomcat_Connector_maxPostSize
Maximum size in bytes of a POST which will be handled by the servlet API provided features.
Tomcat_Connector_connectionTimeout
Timeout value on the incoming connection.
Tomcat_Connector_connectionLinger
Linger value on the incoming connection.
Engine
Tomcat_Engine_backgroundProcessorDelay
The processor delay for this component.
Tomcat_Engine_startChildren
Will children be started automatically when they are added?
Tomcat_Engine_startStopThreads
The number of threads to use when starting and stopping child Hosts.
GlobalRequestProcessor
Tomcat_GlobalRequestProcessor_bytesReceived
Amount of data received, in bytes.
Tomcat_GlobalRequestProcessor_bytesSent
Amount of data sent, in bytes.
Tomcat_GlobalRequestProcessor_errorCount
Number of errors for the GlobalRequestProcessor.
Tomcat_GlobalRequestProcessor_maxTime
Maximum time to process a request.
Tomcat_GlobalRequestProcessor_processingTime
Total time to process the requests.
Tomcat_GlobalRequestProcessor_requestCount
Number of requests processed for the GlobalRequestProcessor.
Host
Tomcat_Host_autoDeploy
The auto deploy flag for this Host.
Tomcat_Host_backgroundProcessorDelay
The processor delay for this component.
Tomcat_Host_copyXML
Should XML files be copied to $CATALINA_BASE/conf/{engine}/{host} by default when a web application is deployed?
Tomcat_Host_createDirs
Should we create directories upon startup for appBase and xmlBase?
Tomcat_Host_deployOnStartup
The deploy on startup flag for this Host.
Tomcat_Host_deployXML
Deploy Context XML config files property.
Tomcat_Host_startChildren
Will children be started automatically when they are added?
Tomcat_Host_startStopThreads
The number of threads to use when starting, stopping, and deploying child Contexts.
Tomcat_Host_undeployOldVersions
Determines if old versions of applications deployed using parallel deployment are automatically undeployed when no longer used. Requires autoDeploy to be enabled.
Tomcat_Host_unpackWARs
Unpack WARs property.
Manager
Tomcat_Manager_activeSessions
Number of active sessions at this moment.
Tomcat_Manager_duplicates
Number of duplicated session ids generated.
Tomcat_Manager_expiredSessions
Number of sessions that expired (doesn’t include explicit invalidations).
Tomcat_Manager_maxActive
Maximum number of active sessions so far.
Tomcat_Manager_maxActiveSessions
The maximum number of active Sessions allowed, or -1 for no limit.
Tomcat_Manager_persistAuthentication
Indicates whether sessions shall persist authentication information when being persisted (e.g. across application restarts).
Tomcat_Manager_processExpiresFrequency
The frequency of the manager checks (expiration and passivation).
Tomcat_Manager_processingTime
Time spent doing housekeeping and expiration.
Tomcat_Manager_rejectedSessions
Number of sessions we rejected due to maxActive being reached.
Tomcat_Manager_sessionAverageAliveTime
Average time an expired session had been alive.
Tomcat_Manager_sessionCounter
Total number of sessions created by this manager.
Tomcat_Manager_sessionCreateRate
Session creation rate in sessions per minute.
Tomcat_Manager_sessionExpireRate
Session expiration rate in sessions per minute.
Tomcat_Manager_sessionMaxAliveTime
Longest time an expired session had been alive.
Tomcat_Manager_warnOnSessionAttributeFilterFailure
Should a WARN level log message be generated if a session attribute fails to match sessionAttributeNameFilter or sessionAttributeClassNameFilter?
ProtocolHandler
Tomcat_ProtocolHandler_acceptCount
Introspected attribute acceptCount.
Tomcat_ProtocolHandler_acceptorThreadCount
Introspected attribute acceptorThreadCount.
Tomcat_ProtocolHandler_acceptorThreadPriority
Introspected attribute acceptorThreadPriority.
Tomcat_ProtocolHandler_allowHostHeaderMismatch
Introspected attribute allowHostHeaderMismatch.
Tomcat_ProtocolHandler_aprRequired
Introspected attribute aprRequired.
Tomcat_ProtocolHandler_compressionMinSize
Introspected attribute compressionMinSize.
Tomcat_ProtocolHandler_connectionCount
Introspected attribute connectionCount.
Tomcat_ProtocolHandler_connectionLinger
Introspected attribute connectionLinger.
Tomcat_ProtocolHandler_connectionTimeout
Introspected attribute connectionTimeout.
Tomcat_ProtocolHandler_connectionUploadTimeout
Introspected attribute connectionUploadTimeout.
Tomcat_ProtocolHandler_desiredBufferSize
Introspected attribute desiredBufferSize.
Tomcat_ProtocolHandler_disableUploadTimeout
Introspected attribute disableUploadTimeout.
Tomcat_ProtocolHandler_keepAliveTimeout
Introspected attribute keepAliveTimeout.
Tomcat_ProtocolHandler_localPort
Introspected attribute localPort.
Tomcat_ProtocolHandler_maxConnections
Introspected attribute maxConnections.
Tomcat_ProtocolHandler_maxExtensionSize
Introspected attribute maxExtensionSize.
Tomcat_ProtocolHandler_maxHeaderCount
Introspected attribute maxHeaderCount.
Tomcat_ProtocolHandler_maxHttpHeaderSize
Introspected attribute maxHttpHeaderSize.
Tomcat_ProtocolHandler_maxHttpRequestHeaderSize
Introspected attribute maxHttpRequestHeaderSize.
Tomcat_ProtocolHandler_maxHttpResponseHeaderSize
Introspected attribute maxHttpResponseHeaderSize.
Tomcat_ProtocolHandler_maxKeepAliveRequests
Introspected attribute maxKeepAliveRequests.
Tomcat_ProtocolHandler_maxSavePostSize
Introspected attribute maxSavePostSize.
Tomcat_ProtocolHandler_maxSwallowSize
Introspected attribute maxSwallowSize.
Tomcat_ProtocolHandler_maxThreads
Introspected attribute maxThreads.
Tomcat*_ProtocolHandler_*maxTrailerSize
Introspected attribute maxTrailerSize.
Tomcat_ProtocolHandler_minSpareThreads
Introspected attribute minSpareThreads.
Tomcat_ProtocolHandler_nameIndex
Introspected attribute nameIndex.
Tomcat_ProtocolHandler_noCompressionStrongETag
Introspected attribute noCompressionStrongETag.
Tomcat_ProtocolHandler_paused
Introspected attribute paused.
Tomcat_ProtocolHandler_pollerThreadCount
Introspected attribute pollerThreadCount.
Tomcat_ProtocolHandler_pollerThreadPriority
Introspected attribute pollerThreadPriority.
Tomcat_ProtocolHandler_port
Introspected attribute port.
Tomcat_ProtocolHandler_portOffset
Introspected attribute portOffset.
Tomcat_ProtocolHandler_portWithOffset
Introspected attribute portWithOffset.
Tomcat_ProtocolHandler_processorCache
Introspected attribute processorCache.
Tomcat_ProtocolHandler_rejectIllegalHeader
Introspected attribute rejectIllegalHeader.
Tomcat_ProtocolHandler_rejectIllegalHeaderName
Introspected attribute rejectIllegalHeaderName.
Tomcat_ProtocolHandler_secure
Introspected attribute secure.
Tomcat_ProtocolHandler_selectorTimeout
Introspected attribute selectorTimeout.
Tomcat_ProtocolHandler_sendfileSupported
Introspected attribute sendfileSupported.
Tomcat_ProtocolHandler_serverRemoveAppProvidedValues
Introspected attribute serverRemoveAppProvidedValues.
Tomcat_ProtocolHandler_sessionCacheSize
Introspected attribute sessionCacheSize.
Tomcat_ProtocolHandler_sessionTimeout
Introspected attribute sessionTimeout.
Tomcat_ProtocolHandler_sniParseLimit
Introspected attribute sniParseLimit.
Tomcat_ProtocolHandler_sSLDisableCompression
Introspected attribute sSLDisableCompression.
Tomcat_ProtocolHandler_sSLDisableSessionTickets
Introspected attribute sSLDisableSessionTickets.
Tomcat_ProtocolHandler_sSLEnabled
Introspected attribute sSLEnabled.
Tomcat_ProtocolHandler_sSLHonorCipherOrder
Introspected attribute sSLHonorCipherOrder.
Tomcat_ProtocolHandler_sSLVerifyDepth
Introspected attribute sSLVerifyDepth.
Tomcat_ProtocolHandler_tcpNoDelay
Introspected attribute tcpNoDelay.
Tomcat_ProtocolHandler_threadPriority
Introspected attribute threadPriority.
Tomcat_ProtocolHandler_trustMaxCertLength
Introspected attribute trustMaxCertLength.
Tomcat_ProtocolHandler_useKeepAliveResponseHeader
Introspected attribute useKeepAliveResponseHeader.
Tomcat_ProtocolHandler_useSendfile
Introspected attribute useSendfile.
Tomcat_ProtocolHandler_useServerCipherSuitesOrder
Introspected attribute useServerCipherSuitesOrder.
Tomcat_ProtocolHandler_waitingProcessorCount
Introspected attribute waitingProcessorCount.
Realm
Tomcat_Realm_available
Introspected attribute available.
Tomcat_Realm_stripRealmForGss
Introspected attribute stripRealmForGss.
Tomcat_Realm_throwOnFailure
Introspected attribute throwOnFailure.
Tomcat_Realm_transportGuaranteeRedirectStatus
Introspected attribute transportGuaranteeRedirectStatus.
Tomcat_Realm_validate
Introspected attribute validate.
RequestProcessor
Tomcat_RequestProcessor_bytesReceived
Introspected attribute bytesReceived.
Tomcat_RequestProcessor_bytesSent
Introspected attribute bytesSent.
Tomcat_RequestProcessor_contentLength
Introspected attribute contentLength.
Tomcat_RequestProcessor_errorCount
Introspected attribute errorCount.
Tomcat_RequestProcessor_lastRequestProcessingTime
Introspected attribute lastRequestProcessingTime.
Tomcat_RequestProcessor_maxTime
Introspected attribute maxTime.
Tomcat_RequestProcessor_processingTime
Introspected attribute processingTime.
Tomcat_RequestProcessor_requestBytesReceived
Introspected attribute requestBytesReceived.
Tomcat_RequestProcessor_requestBytesSent
Introspected attribute requestBytesSent.
Tomcat_RequestProcessor_requestCount
Introspected attribute requestCount.
Tomcat_RequestProcessor_requestProcessingTime
Introspected attribute requestProcessingTime.
Tomcat_RequestProcessor_serverPort
Introspected attribute serverPort.
Tomcat_RequestProcessor_stage
Introspected attribute stage.
Server
Tomcat_Server_port
TCP port (excluding any offset) for shutdown messages.
Tomcat_Server_portOffset
The offset applied to port and to the port attributes of any nested connectors.
Tomcat_Server_portWithOffset
Actual TCP port (including any offset) for shutdown messages.
Servlet
Tomcat_Servlet_available
The date and time at which this servlet will become available (in milliseconds since the epoch), or zero if the servlet is available. If this value equals Long.MAX_VALUE, the unavailability of this servlet is considered permanent.
Tomcat_Servlet_asyncSupported
Async support.
Tomcat_Servlet_backgroundProcessorDelay
The processor delay for this component.
Tomcat_Servlet_classLoadTime
Time taken to load the Servlet class.
Tomcat_Servlet_countAllocated
The count of allocations that are currently active (even if they are for the same instance, as will be true on a non-STM servlet).
Tomcat_Servlet_errorCount
Error count.
Tomcat_Servlet_loadOnStartup
The load-on-startup order value (negative value means load on first call) for this servlet.
Tomcat_Servlet_loadTime
Time taken to load and initialize the Servlet.
Tomcat_Servlet_maxInstances
Deprecated. Will be removed in Tomcat 10.1 onwards. Maximum number of STM instances.
Tomcat_Servlet_maxTime
Maximum processing time of a request.
Tomcat_Servlet_minTime
Minimum processing time of a request.
Tomcat_Servlet_processingTime
Total execution time of the servlet’s service method.
Tomcat_Servlet_requestCount
Number of requests processed by this wrapper.
Tomcat_Servlet_singleThreadModel
Deprecated. Will be removed in Tomcat 10.1 onwards. Does this servlet implement the SingleThreadModel interface?
SSLHostConfig
Tomcat_SSLHostConfig_certificateVerificationDepth
Introspected attribute certificateVerificationDepth.
Tomcat_SSLHostConfig_certificateVerificationDepthConfigured
Introspected attribute certificateVerificationDepthConfigured.
Tomcat_SSLHostConfig_disableCompression
Introspected attribute disableCompression.
Tomcat_SSLHostConfig_disableSessionTickets
Introspected attribute disableSessionTickets.
Tomcat_SSLHostConfig_honorCipherOrder
Introspected attribute honorCipherOrder.
Tomcat_SSLHostConfig_insecureRenegotiation
Introspected attribute insecureRenegotiation.
Tomcat_SSLHostConfig_openSslConfContext
Introspected attribute openSslConfContext.
Tomcat_SSLHostConfig_openSslContext
Introspected attribute openSslContext.
Tomcat_SSLHostConfig_revocationEnabled
Introspected attribute revocationEnabled.
Tomcat_SSLHostConfig_sessionCacheSize
Introspected attribute sessionCacheSize.
Tomcat_SSLHostConfig_sessionTimeout
Introspected attribute sessionTimeout.
Tomcat_SSLHostConfig_tls13RenegotiationAvailable
Introspected attribute tls13RenegotiationAvailable.
SocketProperties
Tomcat_SocketProperties_appReadBufSize
Introspected attribute appReadBufSize.
Tomcat_SocketProperties_appWriteBufSize
Introspected attribute appWriteBufSize.
Tomcat_SocketProperties_bufferPool
Introspected attribute bufferPool.
Tomcat_SocketProperties_bufferPoolSize
Introspected attribute bufferPoolSize.
Tomcat_SocketProperties_directBuffer
Introspected attribute directBuffer.
Tomcat_SocketProperties_directBufferPool
Introspected attribute directBufferPool.
Tomcat_SocketProperties_directSslBuffer
Introspected attribute directSslBuffer.
Tomcat_SocketProperties_eventCache
Introspected attribute eventCache.
Tomcat_SocketProperties_processorCache
Introspected attribute processorCache.
Tomcat_SocketProperties_soLingerOn
Introspected attribute soLingerOn.
Tomcat_SocketProperties_soLingerTime
Introspected attribute soLingerTime.
Tomcat_SocketProperties_soReuseAddress
Introspected attribute soReuseAddress.
Tomcat_SocketProperties_soTimeout
Introspected attribute soTimeout.
Tomcat_SocketProperties_tcpNoDelay
Introspected attribute tcpNoDelay.
Tomcat_SocketProperties_timeoutInterval
Introspected attribute timeoutInterval.
Tomcat_SocketProperties_unlockTimeout
Introspected attribute unlockTimeout.
StringCache
Tomcat_StringCache_accessCount
Introspected attribute accessCount.
Tomcat_StringCache_byteEnabled
Introspected attribute byteEnabled.
Tomcat_StringCache_cacheSize
Introspected attribute cacheSize.
Tomcat_StringCache_charEnabled
Introspected attribute charEnabled.
Tomcat_StringCache_hitCount
Introspected attribute hitCount.
Tomcat_StringCache_trainThreshold
Introspected attribute trainThreshold.
ThreadPool
Tomcat_ThreadPool_acceptCount
Tomcat ThreadPool acceptCount.
Tomcat_ThreadPool_acceptorThreadCount
Tomcat ThreadPool acceptorThreadCount.
Tomcat_ThreadPool_acceptorThreadPriority
Tomcat:name="http-nio-0.0.0.0-9000",type=ThreadPool,attribute=acceptorThreadPriority
Tomcat_ThreadPool_alpnSupported
Tomcat ThreadPool alpnSupported.
Tomcat_ThreadPool_bindOnInit
Tomcat ThreadPool bindOnInit.
Tomcat_ThreadPool_connectionCount
Tomcat ThreadPool connectionCount.
Tomcat_ThreadPool_connectionLinger
Tomcat:name="http-nio-0.0.0.0-9000",type=ThreadPool,attribute=connectionLinger
Tomcat_ThreadPool_connectionTimeout
Tomcat ThreadPool connection timeout.
Tomcat_ThreadPool_currentThreadCount
Tomcat ThreadPool currentThreadCount.
Tomcat_ThreadPool_currentThreadsBusy
The number of currently busy threads in the ThreadPool.
Tomcat_ThreadPool_daemon
Tomcat:name="http-nio-0.0.0.0-9000",type=ThreadPool,attribute=daemon
Tomcat_ThreadPool_deferAccept
Tomcat ThreadPool deferAccept.
Tomcat_ThreadPool_executorTerminationTimeoutMillis
Tomcat:name="http-nio-0.0.0.0-9000",type=ThreadPool,attribute=executorTerminationTimeoutMillis
Tomcat_ThreadPool_keepAliveCount
Tomcat ThreadPool keepAliveCount.
Tomcat_ThreadPool_keepAliveTimeout
Tomcat:name="http-nio-0.0.0.0-9000",type=ThreadPool,attribute=keepAliveTimeout
Tomcat_ThreadPool_localPort
Tomcat:name="http-nio-0.0.0.0-9000",type=ThreadPool,attribute=localPort
Tomcat_ThreadPool_maxConnections
Tomcat ThreadPool maxConnections.
Tomcat_ThreadPool_maxKeepAliveRequests
Tomcat ThreadPool maxKeepAliveRequests.
Tomcat_ThreadPool_maxThreads
Tomcat:name="http-nio-0.0.0.0-9000",type=ThreadPool,attribute=maxThreads
Tomcat_ThreadPool_minSpareThreads
Tomcat:name="http-nio-0.0.0.0-9000",type=ThreadPool,attribute=minSpareThreads
Tomcat_ThreadPool_paused
Tomcat ThreadPool paused.
Tomcat_ThreadPool_pollerThreadCount
Tomcat:name="http-nio-0.0.0.0-9000",type=ThreadPool,attribute=pollerThreadCount
Tomcat_ThreadPool_pollerThreadPriority
Tomcat ThreadPool pollerThreadPriority.
Tomcat_ThreadPool_port
Tomcat ThreadPool port.
Tomcat_ThreadPool_portOffset
Tomcat:name="http-nio-0.0.0.0-9000",type=ThreadPool,attribute=portOffset
Tomcat_ThreadPool_portWithOffset
Tomcat ThreadPool portWithOffset.
Tomcat_ThreadPool_running
Tomcat ThreadPool running.
Tomcat_ThreadPool_selectorTimeout
Introspected attribute selectorTimeout.
Tomcat_ThreadPool_sniParseLimit
Tomcat:name="http-nio-0.0.0.0-9000",type=ThreadPool,attribute=sniParseLimit
Tomcat_ThreadPool_sSLEnabled
Tomcat ThreadPool sSLEnabled.
Tomcat_ThreadPool_tcpNoDelay
Tomcat:name="http-nio-0.0.0.0-9000",type=ThreadPool,attribute=tcpNoDelay
Tomcat_ThreadPool_threadPriority
Tomcat:name="http-nio-0.0.0.0-9000",type=ThreadPool,attribute=threadPriority
Tomcat_ThreadPool_useInheritedChannel
Tomcat ThreadPool useInheritedChannel.
Tomcat_ThreadPool_useSendfile
Tomcat:name="http-nio-0.0.0.0-9000",type=ThreadPool,attribute=useSendfile
UtilityExecutor
Tomcat_UtilityExecutor_activeCount
Introspected attribute activeCount.
Tomcat_UtilityExecutor_completedTaskCount
Introspected attribute completedTaskCount.
Tomcat_UtilityExecutor_continueExistingPeriodicTasksAfterShutdownPolicy
Introspected attribute continueExistingPeriodicTasksAfterShutdownPolicy.
Tomcat_UtilityExecutor_corePoolSize
Introspected attribute corePoolSize.
Tomcat_UtilityExecutor_executeExistingDelayedTasksAfterShutdownPolicy
Introspected attribute executeExistingDelayedTasksAfterShutdownPolicy.
Tomcat_UtilityExecutor_largestPoolSize
Introspected attribute largestPoolSize.
Tomcat_UtilityExecutor_maximumPoolSize
Introspected attribute maximumPoolSize.
Tomcat_UtilityExecutor_poolSize
Introspected attribute poolSize.
Tomcat_UtilityExecutor_removeOnCancelPolicy
Introspected attribute removeOnCancelPolicy.
Tomcat_UtilityExecutor_shutdown
Introspected attribute shutdown.
Tomcat_UtilityExecutor_taskCount
Introspected attribute taskCount.
Tomcat_UtilityExecutor_terminated
Introspected attribute terminated.
Tomcat_UtilityExecutor_terminating
Introspected attribute terminating.
Valve
Tomcat_Valve_asyncSupported
Does this valve support async reporting?
Tomcat_Valve_birthTime
Introspected attribute birthTime.
Tomcat_Valve_cache
Should we cache authenticated Principals if the request is part of an HTTP session?
Tomcat_Valve_changeSessionIdOnAuthentication
Controls if the session ID is changed if a session exists at the point where users are authenticated.
Tomcat_Valve_disableProxyCaching
Controls the caching of pages that are protected by security constraints.
Tomcat_Valve_quiet
Introspected attribute quiet.
Tomcat_Valve_securePagesWithPragma
Controls the caching of pages that are protected by security constraints.
Tomcat_Valve_showReport
Enables/Disables full error reports.
Tomcat_Valve_showServerInfo
Enables/Disables server info on error pages.
Tomcat_Valve_started
Introspected attribute started.
Tomcat_Valve_throwOnFailure
Introspected attribute throwOnFailure.
WebModule
Tomcat_WebModule_antiResourceLocking
Take care not to lock resources.
Tomcat_WebModule_clearReferencesRmiTargets
Should Tomcat look for memory leaks in RMI Targets and clear them if found as a workaround for application coding errors?
Tomcat_WebModule_clearReferencesStopTimerThreads
Should Tomcat attempt to terminate TimerThreads that have been started by the web application? Advisable to be used only in a development environment.
Tomcat_WebModule_clearReferencesStopThreads
Should Tomcat attempt to terminate threads that have been started by the web application? Advisable to be used only in a development environment.
Tomcat_WebModule_clearReferencesThreadLocals
Should Tomcat attempt to clear ThreadLocal variables that have been populated with classes loaded by the web application?
Tomcat_WebModule_configured
The correctly configured flag for this Context.
Tomcat_WebModule_cookies
Should we attempt to use cookies for session id communication?
Tomcat_WebModule_crossContext
Should we allow the ServletContext.getContext() method to access the context of other web applications in this server?
Tomcat_WebModule_delegate
Tomcat WebModule delegate.
Tomcat_WebModule_distributable
The distributable flag for this web application.
Tomcat_WebModule_errorCount
Cumulative error count of all servlets in this context.
Tomcat_WebModule_ignoreAnnotations
Ignore annotations flag.
Tomcat_WebModule_logEffectiveWebXml
Should the effective web.xml be logged when the context starts?
Tomcat_WebModule_mapperContextRootRedirectEnabled
Should the Mapper be used for context root redirects?
Tomcat_WebModule_mapperDirectoryRedirectEnabled
Should the Mapper be used for directory redirects?
Tomcat_WebModule_maxTime
Maximum execution time of all servlets in this context.
Tomcat_WebModule_minTime
Minimum execution time of all servlets in this context.
Tomcat_WebModule_override
The default context.xml override flag for this web application.
Tomcat_WebModule_parallelAnnotationScanning
The parallel annotation scanning flag.
Tomcat_WebModule_paused
The request processing pause flag (while reloading occurs).
Tomcat_WebModule_privileged
Access to Tomcat internals.
Tomcat_WebModule_processingTime
Cumulative execution times of all servlets in this context.
Tomcat_WebModule_reloadable
The reloadable flag for this web application.
Tomcat_WebModule_renewThreadsWhenStoppingContext
Should Tomcat renew the threads of the thread pool when the application is stopped to avoid memory leaks because of uncleaned ThreadLocal variables?
Tomcat_WebModule_requestCount
Cumulative request count of all servlets in this context.
Tomcat_WebModule_sessionTimeout
The session timeout (in minutes) for this web application.
Tomcat_WebModule_startTime
Time (in milliseconds since January 1, 1970, 00:00:00) when this context was started.
Tomcat_WebModule_startupTime
Time (in milliseconds) it took to start this context.
Tomcat_WebModule_swallowOutput
Flag to set to cause the system.out and system.err to be redirected to the logger when executing a servlet.
Tomcat_WebModule_tldScanTime
Time spent scanning jars for TLDs for this context.
Tomcat_WebModule_tldValidation
Should the parsing of *.tld files be performed by a validating parser?
Amount of ms that the container will wait for servlets to unload.
Tomcat_WebModule_unpackWAR
Unpack WAR property.
Tomcat_WebModule_useBloomFilterForArchives
DEPRECATED: Use a bloom filter for archives lookups.
Tomcat_WebModule_useHttpOnly
Indicates that session cookies should use HttpOnly.
Tomcat_WebModule_useNaming
Create a JNDI naming context for this application?
Tomcat_WebModule_useRelativeRedirects
When generating location headers for 302 responses, should a relative URI be used?
Tomcat_WebModule_xmlNamespaceAware
Should the parsing of web.xml and web-fragment.xml files be performed by a namespace-aware parser?
Tomcat_WebModule_xmlValidation
Should the parsing of web.xml and web-fragment.xml files be performed by a validating parser?
WebResourceRoot
Tomcat_WebResourceRoot_allowLinking
Does this resources implementation allow the use of symbolic links?
Tomcat_WebResourceRoot_cachingAllowed
Is in-memory caching of resource content and metadata enabled?
Tomcat_WebResourceRoot_hitCount
The number of requests for resources that were served from the cache.
Tomcat_WebResourceRoot_lookupCount
The number of requests for resources in the WebResourceRoot.
Tomcat_WebResourceRoot_maxSize
The maximum permitted size of the cache in kB.
Tomcat_WebResourceRoot_objectMaxSize
The maximum permitted size for a single object in the cache in kB.
Tomcat_WebResourceRoot_size
The current estimate of the cache size in kB.
Tomcat_WebResourceRoot_trackLockedFiles
Does this resources implementation track requests that lock files?
Tomcat_WebResourceRoot_ttl
The time-to-live for cache entries in milliseconds.
Notes
The Web API metrics follow
sonarqube_snake_casenaming (Prometheus convention), while the JMX metrics useSonarQube_PascalCasenaming (matching JMX MBean object names).JMX-exported metrics appear as
Untypedin Prometheus because JMX MBeans do not carry Prometheus metric type metadata. Treat them as gauges for alerting and dashboard purposes.
Related page
Introduction to setting up monitoring
Last updated
Was this helpful?

